'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = perspective;

var _perspectiveCamera = require('perspective-camera');

var _perspectiveCamera2 = _interopRequireDefault(_perspectiveCamera);

var _create = require('gl-mat3/create');

var _create2 = _interopRequireDefault(_create);

var _create3 = require('gl-mat4/create');

var _create4 = _interopRequireDefault(_create3);

var _useControls = require('../use-controls');

var _useControls2 = _interopRequireDefault(_useControls);

var _update = require('./update');

var _update2 = _interopRequireDefault(_update);

var _updateNormal = require('./update-normal');

var _updateNormal2 = _interopRequireDefault(_updateNormal);

var _updateModelView = require('./update-model-view');

var _updateModelView2 = _interopRequireDefault(_updateModelView);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function PerspectiveCamera(camera) {
  camera.flags = {
    autoUpdate: true,
    autoUpdateViewport: true,
    autoUpdateControls: true
  };

  camera.modelView = (0, _create4.default)();
  camera.normal = (0, _create2.default)();

  camera.updateMatrices = camera.update;
  camera.updateModelView = _updateModelView2.default.bind(null, camera);
  camera.updateNormal = _updateNormal2.default.bind(null, camera);
  camera.update = _update2.default.bind(null, camera);
  camera.use = _useControls2.default.bind(null, camera);

  return camera;
}

function perspective(properties) {
  return PerspectiveCamera((0, _perspectiveCamera2.default)(properties));
}