'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createShaderOrGetCached;

var _glShader = require('gl-shader');

var _glShader2 = _interopRequireDefault(_glShader);

var _stripUnusedFns = require('../shader-parser/strip-unused-fns');

var _stripUnusedFns2 = _interopRequireDefault(_stripUnusedFns);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createShaderOrGetCached(cache, gl, mesh, defines) {
  var material = mesh.material;
  var key = defines + material.vertSource + material.fragSource;
  var cachedEntry = cache[key];

  var shader;

  if (cachedEntry) {
    shader = cachedEntry.shader;
    cachedEntry.meshes.push(mesh);
  } else {
    shader = (0, _glShader2.default)(gl, (0, _stripUnusedFns2.default)(defines + material.vertSource, material.defines), (0, _stripUnusedFns2.default)(defines + material.fragSource, material.defines));

    cache[key] = {
      shader: shader,
      meshes: [mesh]
    };
  }

  return shader;
}