'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _tape = require('tape');

var _tape2 = _interopRequireDefault(_tape);

var _lib = require('../../lib');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _tape2.default)('Engine', function (t) {
  t.test('Verify created a correctly shaped object', function (t) {
    t.plan(5);

    var fn = function fn(intEngine, scene, renderer) {
      t.equal(intEngine, extEngine, 'The external and internal engines match');
      t.equal(typeof scene === 'undefined' ? 'undefined' : _typeof(scene), 'object', 'Provides a scene');
      t.equal(typeof renderer === 'undefined' ? 'undefined' : _typeof(renderer), 'object', 'Provides a renderer');
      renderer.destroy();
    };

    var config = {
      autoStart: false
    };

    var extEngine = (0, _lib.Engine)(fn, config);

    t.equal(_typeof(extEngine.loop), 'object', 'Provides a loop');
    t.equal(_typeof(extEngine.on), 'function', 'Hooks on the event emitter');

    // TODO - Should I test this out more?
  });
});